## ros-melodic-cv-bridge-python3 1.13.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(cv_bridge_python3)

set(Python_ADDITIONAL_VERSIONS 3.6;3.7;3.8) ## https://stackoverflow.com/questions/29245558/how-to-link-with-python3-libs-with-cmake
find_package(PythonInterp 3 REQUIRED) ## cv_bridge_python3 :: use Python3 by default
find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")

find_package(catkin REQUIRED COMPONENTS rosconsole sensor_msgs)

if(NOT ANDROID)
  find_package(PythonLibs)
  if(PYTHONLIBS_VERSION_STRING VERSION_LESS 3)
    find_package(Boost REQUIRED python)
  else()
    find_package(Boost REQUIRED python3)
  endif()
else()
find_package(Boost REQUIRED)
endif()
find_package(OpenCV 3 REQUIRED
  COMPONENTS
    opencv_core
    opencv_imgproc
    opencv_imgcodecs
  CONFIG
)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS rosconsole sensor_msgs
  DEPENDS OpenCV
## cv_bridge_pytyhon3 :: does not install cmakelibrary,
#  CFG_EXTRAS cv_bridge-extras.cmake
)

catkin_python_setup()

include_directories(include ${Boost_INCLUDE_DIRS} ${OpenCV_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS})

## cv_bridge_pytyhon3 :: re-set PROJECT_NAME to cv_bridge
set(PROJECT_NAME cv_bridge)
## cv_bridge_pytyhon3 :: re-set CATKIN_PACKAGE_PYTHON_DESTINATION with PROJECT_NAME as cv_bridge
set(CATKIN_PACKAGE_PYTHON_DESTINATION lib/python${PYTHON_VERSION_MAJOR}/dist-packages/${PROJECT_NAME})

if(NOT ANDROID)
add_subdirectory(python)
endif()
add_subdirectory(src)
if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

# install the include folder
## cv_bridge_python3 :: we can share include/cv_bridge
# install(
#   DIRECTORY include/${PROJECT_NAME}/
#   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
# )

=== src/CMakeLists.txt ===
# add library
include_directories(./)
add_library(${PROJECT_NAME} cv_bridge.cpp rgb_colors.cpp)
add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${PROJECT_NAME} ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})

## cv_bridge_pytyhon3 :: does not install C++ library,
# install(TARGETS ${PROJECT_NAME} DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

if(NOT ANDROID)
# add a Boost Python library
find_package(PythonInterp REQUIRED)
find_package(PythonLibs "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")

#Get the numpy include directory from its python module
if(NOT PYTHON_NUMPY_INCLUDE_DIR)
    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import numpy; print(numpy.get_include())"
                    RESULT_VARIABLE PYTHON_NUMPY_PROCESS
                    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    if(PYTHON_NUMPY_PROCESS EQUAL 0)
       file(TO_CMAKE_PATH "${PYTHON_NUMPY_INCLUDE_DIR}" PYTHON_NUMPY_INCLUDE_CMAKE_PATH)
       set(PYTHON_NUMPY_INCLUDE_DIR ${PYTHON_NUMPY_INCLUDE_CMAKE_PATH} CACHE PATH "Numpy include directory")
    else(PYTHON_NUMPY_PROCESS EQUAL 0)
        message(SEND_ERROR "Could not determine the NumPy include directory, verify that NumPy was installed correctly.")
    endif(PYTHON_NUMPY_PROCESS EQUAL 0)
 endif(NOT PYTHON_NUMPY_INCLUDE_DIR)

include_directories(${PYTHON_INCLUDE_PATH} ${Boost_INCLUDE_DIRS} ${PYTHON_NUMPY_INCLUDE_DIR})

if (PYTHON_VERSION_MAJOR VERSION_EQUAL 3)
  add_definitions(-DPYTHON3)
endif()

if (OpenCV_VERSION_MAJOR VERSION_EQUAL 3)
add_library(${PROJECT_NAME}_boost module.cpp module_opencv3.cpp)
else()
add_library(${PROJECT_NAME}_boost module.cpp module_opencv2.cpp)
endif()
target_link_libraries(${PROJECT_NAME}_boost ${Boost_LIBRARIES}
                                            ${catkin_LIBRARIES}
                                            ${PYTHON_LIBRARIES}
                                            ${PROJECT_NAME}
)

set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_PYTHON_DESTINATION}/${PROJECT_NAME}/boost/
                      RUNTIME_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_PYTHON_DESTINATION}/${PROJECT_NAME}/boost/
                      PREFIX ""
)
if(APPLE)
  set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                        SUFFIX ".so")
endif()
if(MSVC)
  set_target_properties(${PROJECT_NAME}_boost PROPERTIES
                        SUFFIX ".pyd")
endif()

install(TARGETS ${PROJECT_NAME}_boost DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}/boost/)
endif()

=== debian/changelog ===
ros-melodic-cv-bridge-python3 (1.13.2-1bionic) bionic; urgency=high

  * add buildtool_depend for catkin-pkg-modules (#2 <https://github.com/jsk-ros-pkg/vision_opencv_python3/issues/2>)
  * Contributors: Shingo Kitagawa

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 07 Apr 2022 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.13.1-1bionic) bionic; urgency=high

  * depends on python3, change package name to cv_bridge_python3
  * Contributors: Kei Okada

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 21 Mar 2022 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.13.0-1bionic) bionic; urgency=high

  * Use rosdep OpenCV and not ROS one.
    We defintely don't need the whole OpenCV.
    We need to clean the rosdep keys.
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 29 Apr 2018 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.8-1bionic) bionic; urgency=high

  * Merge pull request #191 <https://github.com/ros-perception/vision_opencv/issues/191> from patrickelectric/kinetic
    cv2_to_imgmsg: step must be int
  * cv2_to_imgmsg: step must be int
    Signed-off-by: Patrick José Pereira <mailto:patrickelectric@gmail.com>
  * Contributors: Patrick José Pereira, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 16 Apr 2018 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.7-1bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 11 Nov 2017 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.6-1bionic) bionic; urgency=high

  * fix endianness issues
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 10 Nov 2017 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.5-1bionic) bionic; urgency=high

  * add version_gte for opencv3
    @vrabaud If you'll update opencv3 version as discussed in https://discourse.ros.org/t/opencv-3-3/2674/4, I think we'd better to add 'version_gte' tag so that apt-get install ros-kinetic-cv-bridge also pulls openv3.3 from repository, to avoid API breaking issue between opencv2 and opencv3.
  * Simplify the dependency components of cv_bridge
    Fixes #183 <https://github.com/ros-perception/vision_opencv/issues/183>
  * Fixes #177 <https://github.com/ros-perception/vision_opencv/issues/177>
    The Python bridge was wrong on OpenCV2 with mono8 (and any Mat
    with only two dimensions btw). Took the official Python bridge
    from OpenCV.
  * Add missing test file
    This fixes #171 <https://github.com/ros-perception/vision_opencv/issues/171>
  * Properly deal with alpha in image compression.
    That fixes #169 <https://github.com/ros-perception/vision_opencv/issues/169>
  * Silence warnings about un-used variables
  * export OpenCV variables
  * Contributors: Kei Okada, Victor Lamoine, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 04 Nov 2017 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.4-1bionic) bionic; urgency=high

  * properly find Boost Python 2 or 3
    This fixes #158 <https://github.com/ros-perception/vision_opencv/issues/158>
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 28 Jan 2017 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.3-1bionic) bionic; urgency=high

  * Use api in sensor_msgs to get byte_depth and num channels
  * Implement cpp conversion of N channel image
    This is cpp version of https://github.com/ros-perception/vision_opencv/pull/141,
    which is one for python.
  * Fill black color to depth nan region
  * address gcc6 build error in cv_bridge and tune
    With gcc6, compiling fails with stdlib.h: No such file or directory,
    as including '-isystem /usr/include' breaks with gcc6, cf.,
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=70129
    This commit addresses this issue for cv_bridge in the same way
    it was done in the commit ead421b8 [1] for image_geometry.
    This issue was also addressed in various other ROS packages.
    A list of related commits and pull requests is at:
    https://github.com/ros/rosdistro/issues/12783
    [1] https://github.com/ros-perception/vision_opencv/commit/ead421b85eeb750cbf7988657015296ed6789bcf
    Signed-off-by: Lukas Bulwahn <mailto:lukas.bulwahn@oss.bmw-carit.de>
  * cv_bridge: Add missing test_depend on numpy
  * Contributors: Kentaro Wada, Lukas Bulwahn, Maarten de Vries

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 03 Dec 2016 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.2-1bionic) bionic; urgency=high

  * Specify background label when colorizing label image
  * Adjust to arbitrary image channels like 32FC40
    Proper fix for #141 <https://github.com/ros-perception/vision_opencv/issues/141>
  * Remove unexpectedly included print statement
  * Contributors: Kentaro Wada, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 23 Sep 2016 15:00:00 -0000

ros-melodic-cv-bridge-python3 (1.12.1-1bionic) bionic; urgency=high

  * split the conversion tests out of enumerants
  * support is_bigendian in Python
    Fixes #114 <https://github.com/ros-perception/vision_opencv/issues/114>
    Also fixes mono16 test
  * Support compressed Images messages in python for indigo
    - Add cv2_to_comprssed_imgmsg: Convert from cv2 image to compressed image ros msg.
    - Add comprssed_imgmsg_to_cv2:   Convert the compress message to a new image.
    - Add compressed image tests.
    - Add time to msgs (compressed and regular).
    add enumerants test for compressed image.
    merge the compressed tests with the regular ones.
    better comment explanation. I will squash this commit.
    Fix indentation
    fix typo mistage: from .imgmsg_to_compressed_cv2 to .compressed_imgmsg_to_cv2.
    remove cv2.CV_8UC1
    remove rospy and time depndency.
    change from IMREAD_COLOR to IMREAD_ANYCOLOR.
    - make indentaion of 4.
    - remove space trailer.
    - remove space from empty lines.


=== debian/control ===
Source: ros-melodic-cv-bridge-python3
Section: misc
Priority: optional
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libopencv-dev, python3-catkin-pkg-modules, python3-dev, python3-numpy, python3-opencv, ros-melodic-catkin, ros-melodic-rosconsole, ros-melodic-rostest, ros-melodic-sensor-msgs
Homepage: http://www.ros.org/wiki/cv_bridge
Standards-Version: 3.9.2

Package: ros-melodic-cv-bridge-python3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libopencv-dev, python3-dev, python3-opencv, ros-melodic-rosconsole, ros-melodic-sensor-msgs
Description: This contains CvBridge, which converts between ROS Image messages and OpenCV images.
 == This package intentionally link against boost-python3 and install under /opt/ros/ROS_DISTRO/lib/python3/dist-package Please add import sys, os; sys.path.insert(0,'/opt/ros/' + os.environ['ROS_DISTRO'] + '/lib/python3/dist-packages/') before you call import cv_bridge

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-cv-bridge-python3//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
